// BiblioView.h : interface of the CBiblioView class
//
/////////////////////////////////////////////////////////////////////////////

class CBiblioSet;

class CBiblioView : public CDaoRecordView
{
protected: // create from serialization only
	CBiblioView();
	DECLARE_DYNCREATE(CBiblioView)

public:
	//{{AFX_DATA(CBiblioView)
	enum { IDD = IDD_BIBLIO_FORM };
	CBiblioSet* m_pSet;
	//}}AFX_DATA

// Attributes
public:
	CBiblioDoc* GetDocument();

protected:
	BOOL m_bOnRecordAdd;
	BOOL m_bTransact;
	int m_nTransactions;
	COleVariant m_LastBookmark;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBiblioView)
	public:
	virtual CDaoRecordset* OnGetRecordset();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBiblioView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnMove( UINT nIDMoveCommand );

// Generated message map functions
protected:
	//{{AFX_MSG(CBiblioView)
	afx_msg void OnRecordAdd();
	afx_msg void OnUpdateRecordAdd(CCmdUI* pCmdUI);
	afx_msg void OnRecordDelete();
	afx_msg void OnUpdateRecordDelete(CCmdUI* pCmdUI);
	afx_msg void OnTransactBegin();
	afx_msg void OnUpdateTransactBegin(CCmdUI* pCmdUI);
	afx_msg void OnTransactCommit();
	afx_msg void OnUpdateTransactCommit(CCmdUI* pCmdUI);
	afx_msg void OnTransactRollback();
	afx_msg void OnUpdateTransactRollback(CCmdUI* pCmdUI);
	afx_msg void OnRecordEdit();
	afx_msg void OnUpdateRecordEdit(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnUpdateIndicatorTransact(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BiblioView.cpp
inline CBiblioDoc* CBiblioView::GetDocument()
   { return (CBiblioDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
