// DynaListView.h : interface of the CDynaListView class
//
/////////////////////////////////////////////////////////////////////////////

class CDynaListView : public CListView
{
protected: // create from serialization only
	CDynaListView();
	DECLARE_DYNCREATE(CDynaListView)

// Attributes
public:
	CDynaListDoc* GetDocument();

protected:
	CDaoRecordset* m_pSet;
	CDaoDatabase* m_pDatabase;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDynaListView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

protected:
	void CDynaListView::DeleteListViewData();
	BOOL FillListViewEntries(int nRecords);
	BOOL FillListViewHeaders(int cx);
	
// Implementation
public:
	virtual ~CDynaListView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDynaListView)
	afx_msg void OnFileOpen();
	afx_msg void OnFileClose();
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DynaListView.cpp
inline CDynaListDoc* CDynaListView::GetDocument()
   { return (CDynaListDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
