// BiblioSet.cpp : implementation file
//

#include "stdafx.h"
#include "DBAccess.h"
#include "BibSet.h"

#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBiblioSet

IMPLEMENT_DYNAMIC(CBiblioSet, CDaoRecordset)

CBiblioSet::CBiblioSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CBiblioSet)
	m_Commands = _T("");
	m_Description = _T("");
	m_ISBN = _T("");
	m_Notes = _T("");
	m_PubID = 0;
	m_Subject = _T("");
	m_Title = _T("");
	m_Year_Published = 0;
	m_nFields = 8;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenTable;
	m_bCheckCacheForDirtyFields = FALSE;
}

CString CBiblioSet::GetDefaultDBName()
{
	struct _finddata_t c_file;
    long hFile;
	CString fname = "..\\..\\biblio.mdb";

	hFile = _findfirst(fname, &c_file);

	if( -1 != hFile )
		return _T(fname);

	fname = "..\\biblio.mdb";

	hFile = _findfirst(fname, &c_file);

	if( -1 != hFile )
		return _T(fname);

	return _T("");
}

CString CBiblioSet::GetDefaultSQL()
{
	return _T("[Titles]");
}

void CBiblioSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CBiblioSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[Comments]"), m_Commands);
	DFX_Text(pFX, _T("[Description]"), m_Description);
	DFX_Text(pFX, _T("[ISBN]"), m_ISBN);
	DFX_Text(pFX, _T("[Notes]"), m_Notes);
	DFX_Long(pFX, _T("[PubID]"), m_PubID);
	DFX_Text(pFX, _T("[Subject]"), m_Subject);
	DFX_Text(pFX, _T("[Title]"), m_Title);
	DFX_Short(pFX, _T("[Year Published]"), m_Year_Published);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CBiblioSet diagnostics

#ifdef _DEBUG
void CBiblioSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CBiblioSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
