// ISAPIONE.CPP - Implementation file for your Internet Server
//    IsapiOne Extension

#include "stdafx.h"
#include "IsapiOne.h"

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CIsapiOneExtension, CHttpServer)
	//{{AFX_MSG_MAP(CIsapiOneExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

///////////////////////////////////////////////////////////////////////
// command-parsing map
BEGIN_PARSE_MAP(CIsapiOneExtension, CHttpServer)
	ON_PARSE_COMMAND(GetData, CIsapiOneExtension, ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("FirstName=David")
	ON_PARSE_COMMAND(Default, CIsapiOneExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CIsapiOneExtension)
END_PARSE_MAP(CIsapiOneExtension)

///////////////////////////////////////////////////////////////////////
// The one and only CIsapiOneExtension object
CIsapiOneExtension theExtension;

///////////////////////////////////////////////////////////////////////
// CIsapiOneExtension implementation
CIsapiOneExtension::CIsapiOneExtension()
{
}

CIsapiOneExtension::~CIsapiOneExtension()
{
}

BOOL CIsapiOneExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CIsapiOneExtension command handlers
void CIsapiOneExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	*pCtxt << _T("This ISAPI application supports the function GetData(LPTSTR).\r\n");
	*pCtxt << _T(" The argument is a name you want to locate in ");
	*pCtxt << _T(" c:\\webshare\\wwwroot\\mydata.txt\r\n");

	EndContent(pCtxt);
}

// The following two headers will tell the client never to cache
// this information, as it is dynamic.
static const TCHAR szExpires[] = 
	_T("Expires: Thu, 31 Dec 1997 16:00:00 GMT\r\n");
static const TCHAR szNoCache[] = _T("Pragma: no-cache\r\n");

void CIsapiOneExtension::GetData(CHttpServerContext* pCtxt, LPTSTR pszFirst)
{
	StartContent(pCtxt);
	
	CString fname("c:\\webshare\\wwwroot\\mydata.txt");
	CStdioFile * myfile;
	
	try {
		myfile = new CStdioFile (fname,
						CFile::typeText | CFile::modeRead);
	}
	catch (CFileException * e)
	{
		*pCtxt << "Unable to open " << fname;
		EndContent(pCtxt);
		e->Delete();
		return;
	}

	// Don't allow these pages to be cached
	AddHeader(pCtxt, szExpires);
	AddHeader(pCtxt, szNoCache);

	CString buff;
	BOOL bFound = FALSE;

	// Search the file for the first name.
	// If it's found, set a flag and terminate the loop.
	while (myfile->ReadString(buff))
	{
		if (-1 != buff.Find(pszFirst))
		{
			bFound = TRUE;
			break;
		}
	}
	myfile->Close();
	
	if (bFound)
		*pCtxt << buff;
	else
		*pCtxt << pszFirst << " wasn't found.";

	EndContent(pCtxt);
	
	delete myfile;
}
